/* Tree decomposition 
   Liniarizarea arborelui

   	Se da un arbore cu valori in noduri.
	Operatiile sunt:
	0 x y  (update: valoarea din nodul x devine y)
	1 x y  (query:  determina suma lantului de la x la y - unde x este stramosul lui y)
	 
*/
#include <fstream>
#include <vector>
using namespace std;

ifstream fin("arb.in");
ofstream fout("arb.out");
const int DIM = 1000;
typedef vector<int> VI;

int aint[4 * 2 * DIM]; // 
VI  a;              // nu este necesar (sirul pt care se pastreaza sumele pe intervale in "aint") 
VI FPoz, SPoz, val; // FPoz[x]/SPoz[x] - poz primei aparitii/ultimei a lui x in sirul "a"
bool s[DIM];
VI G[DIM];
int poz, v;         // pozitia in sirul a (si aint[]) pe care se va scrie valoarea v
int timer, n, m;
int A, B;           // intervalul de pozitii de interogare
int suma;           // suma pe interval

void Update(int x, int l, int r);
int Query(int x, int l, int r);

void Df(int x)
{
    s[x] = true;
  
    FPoz[x] = ++timer;     // timpul de descoperire
//  a[timer] = val[x];
    v = val[x]; poz = timer;
    Update(1, 1, 1000);
    
    for (int y : G[x])
        if ( !s[y] )
			Df(y);
    timer++;             // timpul de terminare
 // a[timer] = -val[x]; 
	SPoz[x] = timer;
    v = -val[x]; poz = timer;
    Update(1, 1, 1000);
}    

void Update(int x, int l, int r)
{
    if (l == r)
    {
        aint[x] = v;
        return;
    }    
    int m = (l + r) >> 1;
    if ( poz <= m )
        Update(2 * x, l, m);
    else
        Update(2 * x + 1, m + 1, r);
    aint[x] = aint[2 * x] + aint[2 * x + 1];
}    

int Query(int x, int l, int r)
{
    if ( A <= l and r <= B )
		return aint[x];
   
    int m = (l + r) >> 1;
    int sum = 0;
    if (A <= m)
        sum = Query(2 * x, l, m);
    if (B > m) 
        sum += Query(2 * x + 1, m + 1, r);
    return sum;
}    

void Read()
{
    fin >> n;
    val = VI(n + 1);
    a = VI(2 * n + 1);
    FPoz = SPoz = VI(2 * n + 1);
    for (int i = 1; i <= n; ++i)
        fin >> val[i];
    
    int x, y;
    for ( int i = 1; i < n; ++i)
    {
        fin >> x >> y;
        G[x].push_back(y);
        G[y].push_back(x);
    }
}    

void Debug()
{
    fout << '\n';
    
    for (int i = 1; i <= 2 * n; ++i)
        fout << a[i] << ' ';
    fout << '\n';
}    

int main()
{
    Read();
    Df(1);
  //  Debug();
    fin >> m;
	int op, x, y;
    for (int i = 1; i <= m; ++i)
    {
        fin >> op >> x >> y; // op = 0 update, op = 1, query (suma de la x la y)d
        if (op == 0)       // valoarea din nodul x devine y
        {
            poz = FPoz[x];
            v = y;
            Update(1, 1, 1000);
            
            poz = SPoz[x];
            v = -y;
            Update(1, 1, 1000);
        }    
        else
        {
            A = FPoz[x]; // prima pozitie a lui x
            B = FPoz[x];
			if ( A > B )
				swap(A, B);
     
            fout << Query(1, 1, 1000) << '\n';
        }    
    }    
    fin.close();
    
    return 0;
}
    
